#pragma once
#include "messagebasic.h"
#include <standardglobe.h>

/// <summary>
/// ½ƽ·
/// </summary>
struct MESSAGEBASIC_EXPORT NewPlainRoute : public AbstractMessage {
	QString _route_name;

	NewPlainRoute();

	// Serializable
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ɾƽ·
/// </summary>
struct MESSAGEBASIC_EXPORT RemovePlainRoute : public AbstractMessage {
	QString _route_name;

	RemovePlainRoute();

	// Serializable
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ƽ·
/// </summary>
struct MESSAGEBASIC_EXPORT PlainRouteReset : public AbstractMessage {
	QList<LonLatPos> _lonlat_list;
	QString _route_name;

	PlainRouteReset();

	// Serializable
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ƽ·ݲѯ
/// </summary>
struct MESSAGEBASIC_EXPORT PlainRouteQuery : public AbstractMessage {
	QString _route_name;

	PlainRouteQuery();

	// Serializable
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};

/// <summary>
/// ƽ·
/// </summary>
struct MESSAGEBASIC_EXPORT PlainRouteInfo : public RespondDefault {
	QList<LonLatPos> _lonlat_list;
	QString _route_name;

	PlainRouteInfo();

	// Serializable
	std::shared_ptr<Serializable> newDefault() const override;
	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;
};