#pragma once
#include <DeduceFramework.h>
#include <QDialog>
#include <QTimer>
#include <QListView>
#include <QStandardItemModel>
#include <QTableView>


class PerspectiveView : public QDialog
{
	Q_OBJECT
private:
	std::shared_ptr<DeduceFramework> _bind_framework;
	QTimer *const _bind_timer;

	QListView *const _templet_types;
	QStandardItemModel *const _templet_model;
	QTableView *const _procedure_view;
	QStandardItemModel *const _procedure_model;

	void deduce_start();
	void reply_accept(const QList<std::shared_ptr<WsMessage>>& set);
	void complete_accept(std::shared_ptr<RespondDefault> ins);

	void show_procedures_start(const QModelIndex &target);

public:
	PerspectiveView(std::shared_ptr<DeduceFramework> ins, QWidget* p = nullptr);

signals:
	void backend_deduce_request(std::shared_ptr<const DeduceRequest> ins);
};

